from flask import Flask, render_template
import sqlite3 

app = Flask(__name__)
#===================================================================
# SQLITE settings 
DB_Name = "IoT.db"
WaterRemainingTable = "DHT22_Temperature_Data"
WaterFlowTable = "DHT22_Humidity_Data"

# Sensors to monitor for Litres Left
Sensors = ["Level_Sump","Level_Mid","Level_Top"]

# Sensors to monitor Flow
FlowSensors = ["Flow_Handwash","Flow_Kitchen","Flow_Garden","Flow_Toilets"]

#===================================================================

def update():
	#Connect or Create DB File
	conn = sqlite3.connect(DB_Name)
	curs = conn.cursor()
	WaterRemaining = []
	TotalRemaining = 0
	WaterFlow = []
	TotalFlow = 0
	#curs.execute("SELECT * FROM DHT22_Temperature_Data;")
	#print curs.fetchall() 
	for sensor in Sensors:
		query = "SELECT Lits FROM "+WaterRemainingTable+" WHERE SensorID = '"+sensor+"' ORDER BY id DESC LIMIT 1;"
		curs.execute(query)
		result = curs.fetchone()
		if result is None:
			result = "No Data"
		else:
			result = float(result[0])
			TotalRemaining +=result
		WaterRemaining.append({"Sensor":sensor, "Litsleft":result})
	for sensor in FlowSensors:
		query = "SELECT Litsleft FROM "+WaterFlowTable+" WHERE SensorID = '"+sensor+"' ORDER BY id DESC LIMIT 1;"
		curs.execute(query)
		result = curs.fetchone()
		if result is None:
			result = ["No Data"]
		else:
			result = float(result[0])
			TotalFlow += result
		WaterFlow.append({"Sensor":sensor, "Lits":result})
	#Close DB
	curs.close()
	conn.close()
	#return {"remaining" : WaterRemaining, "flow" : WaterFlow}
        return {"remaining" : WaterRemaining, "flow" : WaterFlow, "timeleft" : TotalRemaining/TotalFlow} 

@app.route("/")
def main():
	return render_template('index.html',data=update())

if __name__ == "__main__":
    app.run()

